/*
 * Copyright 2011-2013 Blender Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __UTIL_MAP_H__
#define __UTIL_MAP_H__

#include <map>
#include <unordered_map>

CCL_NAMESPACE_BEGIN

using std::map;
using std::pair;
using std::unordered_map;
using std::unordered_multimap;

template<typename T> static void map_free_memory(T &data)
{
  /* Use swap() trick to actually free all internal memory. */
  T empty_data;
  data.swap(empty_data);
}

CCL_NAMESPACE_END

#endif /* __UTIL_MAP_H__ */
